#def nsim
;==============================================================
; DCC bost und prog
; Copyright by A. Pischinger (c) 2005
; Steuerung durch DCCser
clock	equ 	20000000 ; 22118400
baud	equ	19200
P3out	equ 	P3out+002h	; tramsmit
; piBOOST Programmer und Booster
; 	RB0		RB1		RB2		RB3
; R0 	loktab eintrag			seri ein	sero ein
; R1	loktab ausgabe			seri aus        sero aus
; R2 					seri anz        sero anz
; R3
; R4
; R5	# bit
; R6	# packet
; R7
;
; B	current byte
;
;protokoll
wieoft	equ	2
null	equ	65536-clock/(1000000/105)
eins	equ	65536-clock/(1000000/58)
#include boost.inc
;
ackbit	dbit	1	; acknowledge bit
ackval	dbit	1	; acknowledge valid
nxtpck	dbit	1	; nchstes packet berechnen
sendkA	dbit	1	; kurzschluss gesendet
sendfA	dbit	1	; frei gesendet
sendbA	dbit	1	; belegt gesendet
sendkB	dbit	1	; kurzschluss gesendet
sendfB	dbit	1	; frei gesendet
sendbB	dbit	1	; belegt gesendet
vkm	dbit	1	; nach start=0, aber pin=1
hkm1	dbit	1	; nach start=0, aber pin=1
belq	dbit	1	; frage belegt
frbel	dbit	1	; send frei/bel automatisch
txdrun	dbit	1	; transmit running
outb0	dbit	1
outb1	dbit	1
outb2	dbit	1
outb3	dbit	1
outbp	dbit	1
hum1	dbit	1
hum2	dbit	1
hum3	dbit	1
hum4	dbit	1
; bytes
;dccsta	equ	004h	; R04, nchstes dcc packet
dccsta	ds	1	; R04, nchstes dcc packet
cam	ds	1	; cv adresse
cal	ds	1
ewrtm	ds	1	; daten msb
ewrtl	ds	1	; daten lsb
kzahl	ds	1	; kurzschlusszhler
fzahl	ds	1	; funktionsausabezhler
durch	ds	1	; durchlaufzhler
ltnxt	ds	1	; loktab next entry
opackl	ds	1	; packet length
opack0	ds	1	; packet data mit adresse
opack1	ds	1	; packet data
opack2	ds	1	; packet data
opack3	ds	1	; packet data
opackp	ds	1	; check byte
;
lokta	ds	loktl
lt2	ds	loktl
lt3	ds	loktl
lt4	ds	loktl
lt5	ds	loktl
lt6	ds	loktl
lokte	ds	0
;
serbia 	equ	080h
serbie	equ	serbia+32
serboa 	equ	serbie
serboe	equ	serboa+32
stack	equ	serboe
;
#section serial
;==============================================================
; si_ interrupt routine mit RB2, transmit mit RB3
	org	_INT_ES		; set int vector
	ljmp	si_		; si_i in rout
	org	serial
si_				; einsprung
	push	PSW
	setb 	RS1		; RB23
	clr	RS0		; RB2
	jnb	TI,si_ti5	; transmit interrupt ?
	clr	TI		; ja
	setb	RS0		; RB3
	cjne	R2,#0,si_ti1
	clr	txdrun
	ajmp	si_ti5
si_ti1
; ein byte aus em ser out buf
	mov	SBUF,@R1	; wert
	inc	R1
	cjne	R1,#serboe,si_ti4
	mov	R1,#serboa
si_ti4
	dec	R2
si_ti5
; ein byte in den ser in buf
	clr	RS0		; RB2
	jnb	RI,si_e
	clr	RI
	mov	@R0,SBUF
	inc	R0
	cjne	R0,#serbie,si_ti7
	mov	R0,#serbia
si_ti7
	inc	R2
si_e
	pop	PSW
	reti
; ein byte in ser out buf
seroib	ds	1
seroi
	push	PSW
	setb	RS1
	setb	RS0	; RB3
	mov	@R0,seroib
	inc	R2
	inc	R0
	cjne	R0,#serboe,seroi0
	mov	R0,#serboa
seroi0
	jb	txdrun,seroi9
	mov	SBUF,@R1
	setb	txdrun
	dec	R2
	inc	R1
	cjne	R1,#serboe,seroi9
	mov	R1,#serboa
seroi9
	pop	PSW
;	ret
#section
;==============================================================
	dccgen
;==============================================================
#section e0i_,noret
	org	_INT_EX0
	ajmp	e0i_
	org	e0i_
#ifdef PROG
; extern int 0 low : acknowledge
	org	_INT_EX0
	jnb	ackval,e0i_e
	setb	ackbit
e0i_e
#endif
#ifdef BOST
; extern int 0 low : kurzschluss / frei eingang A
	jb	dccena,e0i_6	; spannung off
	dccaus
	clr	dccakA		; anzeige Kurzschluss
	jb	sendkA,e0i_6
	setb	sendkA

	seroi	#mshrA		; sende Kurzschluss
e0i_6
#endif
	reti
;==============================================================
#section e1i_,noret
; extern int 1 low : kurzschluss / frei eingang B
	org	_INT_EX1
	ajmp	e1i_
	org	e1i_
;
	jb	dccena,e1i_6	; spannung off
	dccaus
#ifdef BOST
	clr	dccakB		; anzeige Kurzschluss
#endif
#ifdef PROG
	clr	dccaks		; anzeige Kurzschluss
#endif
	jb	sendkB,e1i_6
	setb	sendkB

	seroi	#mshrB 		; sende Kurzschluss
e1i_6
	reti
;==============================================================
#section
;#section reset,noret
	org 	_PROGBEG
reset
	org	000h
	ljmp	reset
	org	reset
	;-------
	clr	RS0		; RB0
	clr	RS1		; RB0
	mov	A,#0
	mov	R0,A
	mov	P1M0,#P1m0
	mov	P1M1,#P1m1
	mov	P1,#0ffh
	mov	P3M0,#P3m0
	mov	P3M1,#P3m1
	mov	P3,#0ffh
	clr	TI
	clr	RI
	mov	R0,#_RAMSIZE
reset0
	mov	@R0,#0
	djnz	R0,reset0
	mov	R0,#lokte
reset1
	dec	R0
	dec	R0
	dec	R0
	dec	R0
	dec	R0
	dec	R0
	dec	R0
	dec	R0
	mov	@R0,#1
	cjne	R0,#lokta,reset1
	mov	SP,#stack
	;-------
	setb	RS1		; RB2
	mov	R0,#serbia
	mov	R1,#serbia
	mov	R2,#0
	setb	RS0		; RB3
	mov	R0,#serboa
	mov	R1,#serboa
	mov	R2,#0
	clr	RS1
	clr	RS0		; RB0
	mov	SCON,#050h	; SMOD Mode 1 8N1
	orl	PCON,#080h	; SMOD takt * 2
	mov	TMOD,#T1MODE2+T0MODE1
dbaud	equ	clock/baud/16
baudtat equ 	clock/16/dbaud
	mov	TL1,#256-dbaud
	mov	TH1,#256-dbaud
	dccaus
	clr 	ET1		; tim 1 int enable
	clr	RI		; rec int
	mov	R0,#lokte	; buffer adr eigen
	setb	TR0		; timer 0 start
	setb	TR1		; timer 1 start
	setb	ES		; serial Int enable
	setb 	ET0		; tim 0 int enable
	setb	IT0		; ext 0 falling edge
	setb 	EX0		; ext 0 int enable : ack
	setb	IT1		; ext 1 falling edge
	setb 	EX1		; ext 1 int enable : short
	setb	PT0		; Timer 0 prio high
	mov	R0,#lokta	; loktab
	mov	R1,#lokta	; loktab
	mov	DPTR,#nbtab
	setb 	dccena		; stop
	clr	sendbA
	clr	sendfA
	clr	sendbB
	clr	sendfB
	mov	R5,#nbprk
	mov	dccsta,#slokt
	setb	nxtpck
	seroi	#mboff
#ifdef BOST
	clr	dccakA
	clr	dccakB
	setb 	frbel		; bel auto off
	setb	sendbA
	setb	sendfA
	setb	sendbB
	setb	sendfB
#endif
#ifdef PROG
	clr	dccaks
	setb	ackbit
;	mov	#wieoft,#3
#endif
	setb	EA		; all interrupt enable
	ajmp	loop
	;-------
;==============================================================
#section loop,noret
;loop1
#ifdef PROG
	mov	C,dcceak	; ack gemerkt
	mov	dccaak,C	; ack anzeigen
#endif
	clr	RS0
	clr	RS1		; RB0
	jbc	nxtpck,loop0
	; inputs verarbeiten
	inputs	1
	inputs	2
#ifdef BOST
	inputs	3
	inputs	4
#endif
	; ser verarbeiten
	clr	RS0
	setb	RS1		; RB2
	mov	A,R2
	clr	RS1		; RB0
	jz	loop
	acall	serv
	ajmp	loop
;---------------
loop0
	mov	A,dccsta	; was als nchstes ?
	anl	A,#03fh
#ifdef PROG
loop16
	cjne	A,#slokt,loop1
	ajmp	lokt
loop1
	cjne	A,#sread,loop2
	ajmp	read
loop2
	cjne	A,#sveri,loop3
	ajmp	veri
loop3
	cjne	A,#swrit,loop
	ajmp	writ
#endif
;==============================================================
;#section lokt,noret
lokt
	;-------	lok table
;	setb	dccacka		; ack reset
	clr	ackbit		; ack reset
	clr	ackval		; ack not valid
	mov	A,ltnxt
	jz	lokt1
	mov	R1,ltnxt
	mov	ltnxt,#0
	mov	fzahl,durch
	mov	A,@R1		; typ
	ajmp	lokt3
lokt1
	cjne	R1,#lokte,lokt2
	mov	R1,#lokta
	mov	durch,#(lokte-lokta)/2
	djnz	fzahl,lokt2
	mov	fzahl,#(lokte-lokta)/2
lokt2
	dec	durch
	mov	A,@R1		; typ
	jnz	lokt3		; nicht leer
lokt21
	inc	R1
	inc	R1
	ajmp	lokt1
lokt3
	cjne	A,#1,lokt4      ; nicht idle
	;-------	idle packet
	packi
	inc	R1
	inc	R1
	ajmp	loop
	;-------
lokt4
	jnb	A.7,lokt5	; spd immer ausgeben
	mov	A,durch
	cjne	A,fzahl,lokt21	; nur eine funktion / durchlauf
lokt5
	mov	R6,#1		; #packets
	mov	opack2,@R1	; speed/funkt
	inc	R1
	mov	opack1,@R1	; idle
	inc	R1
	mov	A,opack1
	xrl	A,opack2
	mov	opackp,A	; prfbyte
	setb	outb1
	setb	outb2
	setb	outbp
	clr	F0		; lnge 3
	ajmp	loop
;==============================================================
#ifdef PROG
;#section read,noret
readb	dbit	1
readr	dbit	1
read13
	seroi	#mreok
	dec	ewrtl
	seroi	ewrtl
	ajmp	read21
read14
	ajmp	read2
read
	mov	A,dccsta
	jb	A.7,read14
	jb	readr,read0
	jb	A.6,read1
	;-------	reset vor read
	packr	5
	orl	dccsta,#040h	; next status read
	mov	durch,#-2
	clr	readb
#ifdef sim
	setb	readb
#endif
	clr	ackbit		; ack reset
	ajmp	loop
read0
	clr	readr
	jb	ackbit,read13	; ackbit high, gefunden
	packr	1
	clr	ackbit		; ack reset
	ajmp	loop
	;-------	read
read1
	setb	ackval
	djnz	durch,read12	; durchlauf zu ende
	jb	readb,read2
	setb	readb		; einmal noch
read12
	jb	ackbit,read13	; ackbit high, gefunden
	mov	R6,#wieoft
	mov	opack1,cam
	orl	opack1,#074h
	mov	opack2,cal
	mov	opack3,ewrtl
	mov	A,opack1
	xrl	A,opack2
	xrl	A,opack3
;	jnb	madr,readna	; mit adresse
;	mov	opack0,lokta+1
;	xrl	A,opack0
;	setb	outb0
;	setb	F1		; mit adresse
;readna	
	mov	opackp,A
	setb	outb1
	setb	outb2
	setb	outb3
	setb	outbp
	setb	F0		; lnge 4
	inc	ewrtl		; next wert
	setb	readr
	ajmp	loop
read2
	;-------	reset nach read
#break
	clr	readb
	seroi	#mreno
read21
	packr	5
	mov	dccsta,#slokt
	clr	ackval		; ack not valid
	clr	ackbit
	mov	durch,#1
	ajmp	loop
;======================================================
;#section veri,noret
veri
	mov	A,dccsta
	jb	A.7,veri2
	jb	A.6,veri1
	;-------	reset vor verify
	packr	6
	orl	dccsta,#040h
	clr	ackbit		; ack reset
	ajmp	loop
	;-------	verify
veri1
	setb	ackval
#ifdef sim
	mov	R6,#1
#else
	mov	R6,#wieoft
#endif
	mov	opack1,cam
	orl	opack1,#074h
	mov	opack2,cal
	mov	opack3,ewrtl
	mov	A,opack1
	xrl	A,opack2
	xrl	A,opack3
;	jnb	madr,verina	; mit adresse
;	mov	opack0,lokta+1
;	xrl	A,opack0
;	setb	outb0
;	setb	F1		; mit adresse
;verina	
	mov	opackp,A
	setb	outb1
	setb	outb2
	setb	outb3
	setb	outbp
	setb	F0		; lnge 4
	orl	dccsta,#080h
	ajmp	loop
veri2
	;-------	reset nach verify
	packr	6
	mov	dccsta,#slokt
	jnb	ackbit,veri3
	seroi	#mveok
	clr	ackval		; ack not valid
	clr	ackbit
	ajmp	loop
	;-------
veri3
	seroi	#mveno
	clr	ackval		; ack not valid
	ajmp	loop
;======================================================
;#section writ,noret
writ
	mov	A,dccsta
	jb	A.7,writ2
	jb	A.6,writ1
	;-------	reset vor write
	packr	6
	orl	dccsta,#040h
	setb	ackval		; ack valid
	clr	ackbit		; ack reset
	ajmp	loop
writ1
	;-------	write
#ifdef sim
	mov	R6,#1
#else
	mov	R6,#wieoft
	inc	R6
	inc	R6
#endif
	mov	opack1,cam	; cv adr msb
	orl	opack1,#07Ch
	mov	opack2,cal	; cv adr lsb
	mov	opack3,ewrtl	; wert
	mov	A,opack1
	xrl	A,opack2
	xrl	A,opack3
;	jnb	madr,writna	; mit adresse
;	mov	opack0,lokta+1
;	xrl	A,opack0
;	setb	outb0
;	setb	F1		; mit adresse
;writna	
	mov	opackp,A
	setb	outb1
	setb	outb2
	setb	outb3
	setb	outbp
	setb	F0		; lnge 4
	
	orl	dccsta,#080h
	ajmp	loop
writ2
	;-------	reset nach write
	packr	6
	mov	dccsta,#slokt
	clr	ackval		; ack not valid
	jnb	ackbit,writ3
	seroi	#mwrok
	clr	ackbit
	ajmp	loop
writ3
	seroi	#mwrno
	ajmp	loop
;======================================================
#endif
siwrtr				; wert lsb
	anl	A,#07fh
	mov	ewrtl,A
	ret
	;-------
siwrtl				; wert msb
	anl	A,#03fh
	mov	ewrtm,A
	ret
	;-------
;
	seroi	A
	ret
	;-------
serv
	setb	RS1
	clr	RS0		; RB2
	mov	A,@R1
	dec	R2
	inc	R1
	cjne	R1,#serbie,serv1
	mov	R1,#serbia
serv1
	clr	RS1		; RB0
	jb	A.ddatr,siwrtr ; $80 daten rechts
	jb	A.ddatl,siwrtl ; $40 daten links
;
siboon
	cjne	A,#cboon,siboff
	clr	dccasp		; booster on
	seroi	#mboon
	jnb	dccena,sibone
	clr	RS0
	dccein
sibone
	ret
	;-------
siboff
	cjne	A,#cboff,sibint
	setb 	dccasp
	dccaus			; booster off
	seroi	#mboff
	ret
	;-------
sibint
#ifdef PROG
	cjne	A,#cbint,sibext
	setb	dccext    	; intern
	seroi	#mbint
	ret
	;-------
sibext
	cjne	A,#cbext,sifbel
	clr	dccext  	; extern
	seroi	#mbext
	ret
	;-------
sifbel
#endif
	cjne	A,#cfbel,siftst
sifbelk
	mov	C,dccena	; belegt
	cpl	C
	mov	belq,C
	dccaus
	mov	TH0,#245
	mov	TL0,#1
	clr	sendbA
	clr	sendfA
	clr	sendbB
	clr	sendfB
	ret
	;-------
siftst
	cjne	A,#cebel,siabel
	clr	frbel		; bel auto on
	clr	sendbB
	clr	sendfB
	seroi	#mebel
	ret
	;-------
siabel
	cjne	A,#cabel,siread
	setb 	frbel		; bel auto off
	setb	sendbB
	setb	sendfB
	seroi	#mabel
	ret
	;-------
siread
	cjne	A,#cread,siveri
	mov	A,ewrtm
	rrc	A
	mov	ewrtm,A
	mov	A,ewrtl
	rl	A
	rrc	A
	mov	ewrtl,A
	mov	dccsta,#1
	setb	nxtpck
	ret
	;-------
siveri
	cjne	A,#cveri,siwrit
	mov	A,ewrtm
	rrc	A
	mov	ewrtm,A
	mov	A,ewrtl
	rl	A
	rrc	A
	mov	ewrtl,A
	mov	dccsta,#2
	setb	nxtpck
	ret
	;-------
siwrit
	cjne	A,#cwrit,sicvad
	mov	A,ewrtm
	rrc	A
	mov	ewrtm,A
	mov	A,ewrtl
	rl	A
	rrc	A
	mov	ewrtl,A
	mov	dccsta,#3
	setb	nxtpck
	ret
	;-------
sicvad
	cjne	A,#ccvad,sioadr
	mov	A,ewrtm
	rrc	A
	mov	cam,A
	mov	A,ewrtl
	rl	A
	rrc	A
	mov	cal,A
	ret
	;-------
sioadr
	mov	R0,#lokta
	ajmp	siloka
#else
	push	A
	mov	A,ewrtm		; lok index
	anl	A,#007h
	cjne	A,#6,sioad0	; 6+7 gibts nicht
sioad0
	jc	siloki
	pop	A
	ret
	;-------
siloki
	add	A,A		; index * 8
	add	A,A
	add	A,A
	add	A,#lokta
	mov	R0,A		; adresse in der lok tab
	pop	A
#endif
siloka
	cjne	A,#cloka,siloks
	mov	@R0,#1		; spd
	inc	R0
	mov	@R0,ewrtl
	inc	R0
	mov	@R0,#0		; fg1
	inc	R0
	mov	@R0,ewrtl
	inc	R0
	mov	@R0,#0		; fg2
	inc	R0
	mov	@R0,ewrtl
	inc	R0
	mov	@R0,#0		; fg3
	inc	R0
	mov	@R0,ewrtl
	ret
	;-------
siloks
	cjne	A,#cloks,silok1
	orl	ewrtl,#040h
	mov	@R0,ewrtl
	ret
	;-------
silok1
	inc	R0
	inc	R0
	cjne	A,#clok1,silok2
	mov	ltnxt,R0
	orl	ewrtl,#080h
	mov	@R0,ewrtl
	ret
	;-------
silok2
	inc	R0
	inc	R0
	cjne	A,#clok2,silok3
	mov	ltnxt,R0
	orl	ewrtl,#0b0h
	mov	@R0,ewrtl
	ret
	;-------
silok3
	inc	R0
	inc	R0
	cjne	A,#clok3,siende
	mov	ltnxt,R0
	orl	ewrtl,#0a0h
	mov	@R0,ewrtl
	;-------
siende
	ret
;===============
	end
